from enum import Enum

class WiiUHardwareVersion(Enum):
    # Definitions taken from https://wut.devkitpro.org/bsp_8h_source.html
    # zlib license
    BSP_HARDWARE_VERSION_UNKNOWN = 0x00000000

    # vWii Hardware Versions
    BSP_HARDWARE_VERSION_HOLLYWOOD_ENG_SAMPLE_1 = 0x00000001
    BSP_HARDWARE_VERSION_HOLLYWOOD_ENG_SAMPLE_2 = 0x10000001
    BSP_HARDWARE_VERSION_HOLLYWOOD_PROD_FOR_WII = 0x10100001
    BSP_HARDWARE_VERSION_HOLLYWOOD_CORTADO = 0x10100008
    BSP_HARDWARE_VERSION_HOLLYWOOD_CORTADO_ESPRESSO = 0x1010000C
    BSP_HARDWARE_VERSION_BOLLYWOOD = 0x20000001
    BSP_HARDWARE_VERSION_BOLLYWOOD_PROD_FOR_WII = 0x20100001

    # WiiU Hardware Versions
    BSP_HARDWARE_VERSION_LATTE_A11_EV = 0x21100010
    BSP_HARDWARE_VERSION_LATTE_A11_CAT = 0x21100020
    BSP_HARDWARE_VERSION_LATTE_A12_EV = 0x21200010
    BSP_HARDWARE_VERSION_LATTE_A12_CAT = 0x21200020
    BSP_HARDWARE_VERSION_LATTE_A2X_EV = 0x22100010
    BSP_HARDWARE_VERSION_LATTE_A2X_CAT = 0x22100020
    BSP_HARDWARE_VERSION_LATTE_A3X_EV = 0x23100010
    BSP_HARDWARE_VERSION_LATTE_A3X_CAT = 0x23100020
    BSP_HARDWARE_VERSION_LATTE_A3X_CAFE = 0x23100028
    BSP_HARDWARE_VERSION_LATTE_A4X_EV = 0x24100010
    BSP_HARDWARE_VERSION_LATTE_A4X_CAT = 0x24100020
    BSP_HARDWARE_VERSION_LATTE_A4X_CAFE = 0x24100028
    BSP_HARDWARE_VERSION_LATTE_A5X_EV = 0x25100010
    BSP_HARDWARE_VERSION_LATTE_A5X_EV_Y = 0x25100011
    BSP_HARDWARE_VERSION_LATTE_A5X_CAT = 0x25100020
    BSP_HARDWARE_VERSION_LATTE_A5X_CAFE = 0x25100028
    BSP_HARDWARE_VERSION_LATTE_B1X_EV = 0x26100010
    BSP_HARDWARE_VERSION_LATTE_B1X_EV_Y = 0x26100011
    BSP_HARDWARE_VERSION_LATTE_B1X_CAT = 0x26100020
    BSP_HARDWARE_VERSION_LATTE_B1X_CAFE = 0x26100028

    def __str__(self):
        return self.name.removeprefix("BSP_HARDWARE_VERSION_").replace("_", " ").title().replace("Cat", "CAT").replace("Cafe", "CAFE").replace("Ev", "EV")
